/**
 * SYS 系统设置
 * admin 系统用户
 * erp 供应链管理
 *    basic 基础信息管理
 *    bill  单据管理
 * crm crm会员管理
 * franchisee 加盟商
 * srd 店铺管理
 **/
export default [
  {
    path: '/user',
    layout: false,
    routes: [
      {
        name: '系统登录',
        path: '/user/login',
        component: './user/login',
        access: 'k1',
      },
    ],
  },
  {
    name: '系统管理',
    icon: 'SettingOutlined',
    path: '/sys',
    routes: [
      {
        name: '系统菜单',
        icon: 'smile',
        path: '/sys/menus',
        component: './sys/menus',
        access: 'k6',
      },
      // {
      //   name: '字典信息',
      //   icon: 'smile',
      //   path: '/sys/dictionary/dictdata',
      //   component: './sys/dictionary/dictdata',
      //   access: 'k6',
      // },
      {
        name: '字典类型',
        icon: 'smile',
        path: '/sys/dictionary/dicttype',
        component: './sys/dictionary/dicttype',
        access: 'k6',
      },
      // {
      //   name: '操作日志',
      //   icon: 'smile',
      //   path: '/sys/log',
      //   component: './sys/log',
      //   access: 'k3',
      // },
      // {
      //   name: '错误日志',
      //   icon: 'smile',
      //   path: '/sys/log',
      //   component: './sys/log',
      //   access: 'k3',
      // },
      
    ],
  },
  {
    name: '加盟商管理',
    icon: 'SettingOutlined',
    path: '/company',
    routes: [
      {
        name: '账号管理',
        icon: 'smile',
        path: '/company/account',
        component: './company/account',
        access: 'k2',
      },
    ]
  },
  {
    name: '组织管理',
    icon: 'SettingOutlined',
    path: '/org',
    routes: [
      {
        name: '机构管理',
        icon: 'smile',
        path: '/org/orgamange',
        component: './org/orgamange',
        access: 'k2',
      },
      {
        name: '角色管理',
        icon: 'smile',
        path: '/org/roles',
        component: './org/roles',
        access: 'k5',
      },
      {
        name: '用户账号管理',
        icon: 'smile',
        path: '/org/users',
        component: './org/users',
        access: 'k5',
      },
    ]
  },
  {
    name: '元数据管理',
    icon: 'DropboxSquareFilled',
    path: '/database',
    routes: [
      {
        name: '物料管理',
        icon: 'smile',
        path: '/database/basic/batching',
        component: './database/basic/batching',
        access: 'k7',
      },
     
      {
        name: '商品管理',
        icon: 'smile',
        path: '/database',
        routes: [
          {
            name: '商品类型',
            icon: 'smile',
            path: '/database/goods/goodstypemanage',
            component: './database/goods/goodstypemanage',
            access: 'k7',
          },
          {
            name: '商品多属性',
            icon: 'smile',
            path: '/database/goods/goodsattribute',
            component: './database/goods/goodsattribute',
            access: 'k7',
          },
          {
            name: '商品基础信息',
            icon: 'smile',
            path: '/database/goods/newgoods',
            component: './database/goods/newgoods',
            access: 'k7',
          },
          {
            name: '添加商品基础信息',
            icon: 'smile',
            path: '/database/goods/goodsInfo',
            component: './database/goods/goodsInfo',
            access: 'k7',
          },
        ]
      },
    ],
  },
  {
    name: '设备管理',
    icon: 'BankFilled',
    path: '/device',
    routes: [
      {
        name: '产品管理',
        icon: 'smile',
        path: '/device/product',
        component: './device/product',
        access: 'k12',
      },
      {
        name: '设备信息',
        icon: 'smile',
        path: '/device/deviceInfo',
        component: './device/deviceInfo',
        access: 'k14',
      },
      {
        name: '版本管理',
        icon: 'smile',
        path: '/device/deviceVesion',
        component: './device/deviceVesion',
        access: 'k14',
      },
      {
        name: '产品功能',
        icon: 'smile',
        path: '/device/productmanage',
        component: './device/productmanage',
        access: 'k14',
      },
      // {
      //   name: '设备工艺信息',
      //   icon: 'smile',
      //   path: '/device/devicetechnology',
      //   component: './device/devicetechnology',
      //   access: 'k9',
      // },
      // {
      //   name: '设备商品管理',
      //   icon: 'smile',
      //   path: '/device/deviceFood',
      //   component: './device/deviceFood',
      //   access: 'k14',
      // },
    ],
  },
  {
    path: '/groupMeal/shop',
    icon: 'SettingOutlined',
    name: '场景管理',
    component: './groupMeal/shop',
  },
  {
    name: '会员管理',
    icon: 'BankFilled',
    path: '/groupMeal/member',
    routes: [
      {
        name: '会员信息',
        icon: 'smile',
        path: '/groupMeal/member/memberInfo',
        component: './groupMeal/member/memberInfo',
      },
      {
        name: '会员标签',
        icon: 'smile',
        path: '/groupMeal/member/membertag',
        component: './groupMeal/member/membertag',
      },
    ]},
  {
    name: '一卡通管理',
    icon: 'BankFilled',
    path: '/groupMeal/oneCard',
    routes: [
      {
        name: '档口管理',
        icon: 'smile',
        path: '/groupMeal/oneCard/gate',
        component: './groupMeal/oneCard/gate',
      },
      {
        name: '刷卡机管理',
        icon: 'smile',
        path: '/groupMeal/oneCard/machine',
        component: './groupMeal/oneCard/machine',
      },
      {
        name: '储值卡管理',
        icon: 'smile',
        path: '/groupMeal/oneCard/storedValueCard',
        component: './groupMeal/oneCard/storedValueCard',
      },
      {
        name: '账号管理',
        icon: 'smile',
        path: '/groupMeal/oneCard/memberAccount',
        component: './groupMeal/oneCard/memberAccount',
      },
      {
        name: '报表统计',
        icon: 'BankFilled',
        path: '/groupMeal/oneCard/ReportStatistics',
        routes: [
          {
            name: '预定报表',
            icon: 'smile',
            path: '/groupMeal/oneCard/ReportStatistics/reservation',
            component: './groupMeal/oneCard/ReportStatistics/reservation',
          },
          {
            name: '计次就餐天消费',
            icon: 'smile',
            path: '/groupMeal/oneCard/ReportStatistics/dayConsumption',
            component: './groupMeal/oneCard/ReportStatistics/dayConsumption',
          },
          {
            name: '月餐段汇总',
            icon: 'smile',
            path: '/groupMeal/oneCard/ReportStatistics/monthSummary',
            component: './groupMeal/oneCard/ReportStatistics/monthSummary',
          },
          {
            name: '月餐段消费',
            icon: 'smile',
            path: '/groupMeal/oneCard/ReportStatistics/monthTimeSlot',
            component: './groupMeal/oneCard/ReportStatistics/monthTimeSlot',
          },
        ],
      },
    ],
  },
  {
    name: '小程序管理',
    icon: 'BankFilled',
    path: '/groupMeal/applet',
    routes: [
      {
        name: '页面管理',
        icon: 'smile',
        path: '/groupMeal/applet/paytemplate',
        component: './groupMeal/applet/paytemplate',
      },
      {
        name: '素材管理',
        icon: 'smile',
        path: '/groupMeal/applet/basicconfiguration',
        component: './groupMeal/applet/basicconfiguration',
      },
      {
        name: '小程序基础配置',
        icon: 'smile',
        path: '/groupMeal/applet/appidmanager',
        routes: [
          {
            name: '支付配置',
            icon: 'smile',
            path: '/groupMeal/applet/appidmanager/payment',
            component: './groupMeal/applet/appidmanager/payment',
          },
          {
            name: 'APPID',
            icon: 'smile',
            path: '/groupMeal/applet/appidmanager/appid',
            component: './groupMeal/applet/appidmanager/appid',
          },
        ],
      },
    ],
  },
  {
    name: '订单管理',
    icon: 'BankFilled',
    path: '/order',
    routes: [
      {
        name: '订单流水',
        icon: 'smile',
        path: '/order/orderflow',
        component: './order/orderflow',
      },
      {
        name: '第三方订单',
        icon: 'smile',
        path: '/order/thirdOrder',
        component: './order/thirdOrder',
      },
      {
        name: '店铺授权',
        icon: 'smile',
        path: '/order/thirdOrder',
        component: './order/thirdOrder',
      },
      {
        name: '授权管理',
        icon: 'smile',
        path: '/order/thirdAuthorize',
        component: './order/thirdAuthorize',
      },
    ],
  },
  {
    path: '/',
    redirect: '/welcome',
  },
  {
    path: '/welcome',
    name: 'welcome',
    icon: 'smile',
    component: './Welcome',
  },

  //什么都不要想404直接放最后
  {
    component: './404',
  },
];
