import { PlusOutlined } from '@ant-design/icons';
import { Popconfirm, Modal, Button, message, Card, Col, Row,ConfigProvider ,Select,Form,Input,Checkbox,Tree,Empty } from 'antd';
import React, { useEffect, useState, useRef } from 'react';
import { PageContainer, FooterToolbar } from '@ant-design/pro-layout';
import ProForm from '@ant-design/pro-form';
import api from '../services';
import { DragSortTable } from '@ant-design/pro-table';
import { MenuOutlined } from '@ant-design/icons';
import { BetaSchemaForm } from '@ant-design/pro-form';
import { fromPairs } from 'lodash';
import '../index.css'
const key = 'message';
const customizeRenderEmpty = () => (
  <Empty />
)
const BomTechnology = (props) => {
  /** 新建/更新窗口的弹窗 */
  const [check, setcheck] = useState(false);
  const [stockGoods, setstockGoods] = useState([]);
  const [technologydata, settechnologydata] = useState([]);
  const [gyname, setgyname] = useState('步骤');
  const [goodstechnologydata, setgoodstechnologydata] = useState([]);
  const [goodstechnologydatabom, setgoodstechnologydatabom] = useState([]);
  const [datacheckbatcloum, setdatacheckbatcloum] = useState([]);
  const [isBatch, setisBatch] = useState(false);
  const [stepName,setstepName]=useState('')
  const [technologyId,settechnologyId]=useState();
  const [columns,setcolumns]=useState([]);
  const formRef = React.useRef(null);
  const actionRef = useRef();
  useEffect(() => {
    /** 获取原料名称*/
    async function initStockGoods() {
      setgyname('步骤')
        let params={}
        if (props.values.id != undefined) {
            params.bomId = props.values.id;
            params.current = 1;
            params.pageSize = 100;
          }
        await api.getentrypage(params).then((r) => {
        var arr = r.data.data;
        setstockGoods(arr)
      });
    }
    async function initTechnilogy(){
        let params={}
        params.current = 1;
        params.pageSize = 100;
        await api.GetGoodstechnologypage(params).then((r) => {
            var arr = r.data.data;
            settechnologydata(arr)
        })
    }
    if(props.bomTechnologyModalVisible){
        initStockGoods(); //回调原料信息
        initTechnilogy();
        setcolumns([])
        getgetGoodstechnology();
    }
    
  }, [props.bomTechnologyModalVisible]);
  async function getgetGoodstechnology(){
    await api.GetGoodsTechnology().then((r) => {
      var data = r.data;
      var sd=[]
      if(data.length>0){
        data.forEach((x) => {
          sd.push({label:x.name,value:x.id,isBatch:x.isBatch});
        });
        setgoodstechnologydata(sd)
      }
    });
    await api.getbomtechnologyactionbybom(props.values.id).then((r) => {
      var data = r.data;
      var sd=[]
     
      if(data){
        data.forEach((x,index) => {
          sd.push({title:x.stepName,key:x.id,value:x.id,actionjson:x.actionJson,chnologyId:x.chnologyId,isBatch:x.isBatch,sort:x.sort,index:index});
        });
        setgoodstechnologydatabom(sd)
      }
    });
    
  }
 //选择步骤事件
  const onclockgan=async (item)=>{
    setcolumns([])
    setdatacheckbatcloum([]);
    formRef.current?.setFieldsValue({
      stepName: item.title,
      id:item.key
    });
    setisBatch(item.isBatch)
    settechnologyId(item.chnologyId)
    setgyname('【'+item.title+'】步骤')
    let json=JSON.parse(item.actionjson);
    if(!item.isBatch){
      SchemaForminitialValue(item.chnologyId,json)
    }else{
      await BomForminitialValue(stockGoods,json);
    }
   
  }
  //工艺下拉事件
  const interdata=(id,option)=>{
    
    setcolumns([]);
    setdatacheckbatcloum([]);
    //setdatacheckbatcloum([]);
    settechnologyId(id)
    var name=option.label;
    setstepName(name);
    formRef.current?.setFieldsValue({
      stepName: name,
      id:""
    });
    setgyname('【'+name+'】步骤')
    var act=[]
    if(option.isBatch){
      setisBatch(false)
      SchemaForminitialValue(id,act)
      }else{
        setisBatch(true)
        BomForminitialValue(stockGoods,act)
      }
  }
   //物料工艺选中事件 value绑定的物料信息 datalist已经选择或者原来绑定的数据
  const onChange=(el,id,value,datalist,e)=>{
    var ley=value.find(x=>x.batchingId==id);
    var le={TechnologyactionId:"",ActionName:ley.batchingName,ActionValue:ley.bomQty,BatchingId:ley.batchingId}
    if(e.target.checked){
      //checkdata.push(ley)
      datalist.push(le)
    }else{
      datalist.splice(datalist.findIndex(item => item.BatchingId===le.BatchingId), 1)
      //checkdata.splice(checkdata.indexOf(value),1)
    }
    setdatacheckbatcloum(datalist)
    BomForminitialValue(value,datalist)
  }
  //处理动态表单函数(动作动态表单)
  const SchemaForminitialValue =async (value,actionJson) => {
    var clo=[];
    await api.gettechnologyactionList(value).then((r) => {
      var data = r.data;
     for (let index = 0; index < data.length; index++) {
        //处理下拉框选项
        var ops={};
        if(data[index].actionType=='select'){
          if(data[index].actionValue){
              var va=JSON.parse(data[index].actionValue);
              for (let i = 0; i < va.length; i++) {
                  var op={text: va[i].actionValueName};
                  ops[va[i].actionValueName]=op
              }
          }
        }
        //绑定默认值
        const defaltvalue='';
        for (let t = 0; t < actionJson?.length; t++) {
            const defvalue = actionJson[t];
            //console.log(data[index].id+':'+data[index].actionName+"====="+defvalue.TechnologyactionId+":"+defvalue.ActionName)
            if(data[index].actionType=='select'){
                if(data[index].id+':'+data[index].actionName==defvalue.TechnologyactionId+":"+defvalue.ActionName){
                  defaltvalue=defvalue.ActionValue;
                }
            }else{
              if(data[index].actionName==defvalue.ActionName){
                defaltvalue=defvalue.ActionValue;
              }
                
            }
        }
        const element = 
        {
          title: data[index].actionName,
          dataIndex:data[index].id+':'+data[index].actionName,
          valueType:data[index].actionType,
          //valueEnum:ops,
          width: 'md',
          initialValue:defaltvalue
        };
        if(data[index].actionType=="select"){
          element.valueEnum=ops;
        }
        clo.push(element)
     }
     setcolumns(clo)
    });
  };
  //处理动态表单函数(物料动态表单)
  const BomForminitialValue =async (value,datalist) => {
    //console.log(datacheckbatcloum)
    var clo=[];
    setcolumns([]);
    var data = value;
    var defaltvaluewl=0;
    let df=[];
    for (let index = 0; index < data.length; index++) {
      //let check=checke;
      defaltvaluewl=datalist?.find(it=>it.BatchingId==data[index].batchingId)?.ActionValue;
      let check=false;
      if(defaltvaluewl){
        check=true;
        df.push({TechnologyactionId:"",ActionName:data[index].batchingName,ActionValue:"'"+data[index].bomQty+"'",BatchingId:data[index].batchingId})
      }
      var attrname=data[index].batchingId+':'+data[index].batchingName;
      const element = 
      {
        // key:index,
        title: checkbox(check,data[index].batchingId,data[index].batchingName,value,datalist),
        dataIndex:data[index].batchingId+':'+data[index].batchingName,
        valueType:"text",
        width: 'md',
        initialValue:defaltvaluewl??0
      }
      clo.push(element)
      //更新值
      formRef.current?.setFieldsValue({
        [attrname]:defaltvaluewl
      });
    }
    setdatacheckbatcloum(df)
    setcolumns(clo)
   
  };
  function checkbox(check,id,name,value,datalist) {
    return <Checkbox checked={check} key={id} onChange={onChange.bind(this,id+':'+name,id,value,datalist)}>{name}</Checkbox>;
  }
  //保存数据
  const onFinish=async (value)=>{
    var data=[];
    var parmdata={BomId:props.values.id,ChnologyId:technologyId,ActionJson:'',StepName:value.stepName,isBatch:isBatch,Id:value.id}
    //var parmwldata=[]
    var datas=Object.keys(value);
    var keys=[];
    if(isBatch){
      for (let y = 0; y < datacheckbatcloum.length; y++) {
        let fg = datacheckbatcloum[y];
        keys.push(fg.BatchingId+":"+fg.ActionName);
      }
    }else{
      keys=datas;
    }
    console.log(keys)
    for (var i in keys) {
      if(keys[i]!="stepName"){
        var parm={TechnologyactionId:'',ActionName:'',ActionValue:'',BatchingId:''}
        if(isBatch){
          parm.TechnologyactionId="";
          if(datacheckbatcloum.length>0){
            parm.BatchingId=datacheckbatcloum?.find(x=>x.BatchingId==keys[i].split(':')[0]).BatchingId;
          }
        }else{
          parm.TechnologyactionId=keys[i].split(':')[0];
        }
        parm.ActionValue=value[keys[i]];
        parm.ActionName=keys[i].split(':')[1];
        data.push(parm)
        // if(!isBatch){
        //   var parm={BatchingId:'',total:0,sort:0,ChnologyId:technologyId}
        //   parm.BatchingId=keys[i].split(':')[0];
        //   parm.total=value[keys[i]]
        //   parm.sort=value[keys[i].split(':')[0]+":sort"]
        //   parmwldata.push(parm)
        // }
        
      }
    }
    parmdata.ActionJson=JSON.stringify(data)
    console.log(parmdata)
    if(parmdata.ActionJson.length<=2){
      message.error("请选择工艺并配置相关动作步骤");
      return false;
    }else{
      await api.addbomtechnologyaction(parmdata).then((r) => {
        if(r.succeeded){
          message.success("保存成功")
        }else{
          message.error("保存失败，失败原因："+r.errors)
        }
      })
      // if(!isBatch){
      //   await api.addBomtechnology(parmwldata).then((r) => {
      //     if(r.succeeded){
      //       //message.success("保存成功")
      //     }else{
      //       message.error("保存失败，失败原因："+r.errors)
      //     }
      //   })
      // }
    }
    
    getgetGoodstechnology();
  }
  const ondelete=async (id)=>{
    console.log(id)
    await api.deletebomtechnologyaction(id).then((r) => {
      if(r.succeeded){
        message.success("删除成功");
        getgetGoodstechnology();
      }else{
        message.error("删除成功，失败原因："+r.errors);
      }
    })
  }
  const onDrop =async (info) => {
    //console.log(info);
    const dropKey = info.node.key;
    const dragKey = info.dragNode.key;
    const dropPos = info.node.pos.split('-');
    const dropPosition = info.dropPosition - Number(dropPos[dropPos.length - 1]);
    const loop = (data, key, callback) => {
      for (let i = 0; i < data.length; i++) {
        if (data[i].key === key) {
          return callback(data[i], i, data);
        }
        if (data[i].children) {
          loop(data[i].children, key, callback);
        }
      }
    };
    const data = [...goodstechnologydatabom];
    let dragObj;
    loop(data, dragKey, (item, index, arr) => {
      arr.splice(index, 1);
      dragObj = item;
    });
      let ar = [];
      let i;
      loop(data, dropKey, (_item, index, arr) => {
        ar = arr;
        i = index;
      });
      if (dropPosition === -1) {
        ar.splice(i, 0, dragObj);
      } else {
        ar.splice(i + 1, 0, dragObj);
      }
    console.log(data)
    let parm=[];
    var startsort=0
    for (let index = goodstechnologydatabom[0].sort; startsort < data.length; index++) {
      const element = data[startsort];
      var item=goodstechnologydatabom[startsort];
      //console.log(item)
      if(element.value!=item.value){
        parm.push({id:element.value,sort:index})
      }
      startsort++;
    }
    console.log(parm)
    setgoodstechnologydatabom(data);
    await api.updatesortbomtechnologyaction(parm).then((r) => {
      if(r.succeeded){
        message.success("修改列表排序成功");
        actionRef.current?.reload();
      }else{
        message.error("修改列表排序失败："+r.errors);
      }
    })
  };
  const onDragEnter = (info) => {
    console.log(info);
    // expandedKeys, set it when controlled is needed
    // setExpandedKeys(info.expandedKeys)
  };
 
  return <>
    <Modal
    title={'添加配方工艺'}
    width={1040}
    visible={props.bomTechnologyModalVisible}
    bodyStyle={{ padding: '32px 40px 48px' }}
    footer={null}
    onCancel={() => {
      props.onCancel();
    }}
    destroyOnClose
  >
     
    <Row gutter={16}>
    <Col span={8}>
   
<Card title="工艺步骤" style={{width: 320}} bodyStyle={{padding:1,lineheight:40}} size="small">

    <Tree defaultExpandAll={true} onSelect={(e, info) => [onclockgan(info.node)]} 
    titleRender={(nodeData) => {
      return (
          <div style={{"line-height":40}}>
              <span>{nodeData.title}</span>
              <Popconfirm
          type="primary"
          key="primary"
          title="确认删除吗？"
          okText="是"
          cancelText="否"
          onConfirm={() => {
            ondelete(nodeData.key)
          }}
          onCancel={() => { }}
        >
          <a href="#" style={{color: '#ff4d4f',float:'right'}}>删除</a>
        </Popconfirm>
              {/* <a  onClick={() => {
                ondelete(nodeData.key)
              }} style={{color: '#ff4d4f',float:'right'}}>删除</a> */}
              
          </div>
      )
    }}
    draggable={{
      icon:<MenuOutlined style={{ cursor: 'grab', color: '#080808',"line-height":45 }} />
    }}
    blockNode
    onDragEnd={onDragEnter}
    onDrop={onDrop}
    treeData={goodstechnologydatabom} />
     
 </Card>
  </Col>
  <Col span={8}>

    <Card
      title={gyname}
      extra={
      <span>选择工艺：
      <Select  style={{width: '150px'}}
            options={goodstechnologydata}
            onChange={async (value,option) => {interdata(value,option)}}>
      </Select></span> }
      style={{width: 600}}>
      <Form
          layout="horizontal"
          labelAlign='right'
          preserve={false}
          ref={formRef}
          labelCol={{span: 4}}
          wrapperCol={{span: 24}}
          // initialValues={props.values}
          onFinish={async (value) => onFinish(value)}
        >
          <Form.Item name="id" hidden={true}>
          <Input />
        </Form.Item>
          <Form.Item name="stepName" label="步骤名称"  rules={[{ required: true, message: '请输入步骤名称' }]}>
            <Input placeholder="请输入步骤名称" defaultValue={stepName} style={{width:328}}></Input>
          </Form.Item>
          <BetaSchemaForm
            layoutType="Embed"
            grid={true}
            // rowProps={{gutter: [17,17]}}
            // colProps={{span: 20}}
           shouldUpdate={true}
            formItemProps={{
              forceRender: true,
              labelAlign:'left',
            }}
            columns={columns}
          />
          <Form.Item style={{"text-align":'center'}}>
            <Button type="primary" htmlType="submit" style={{right:10}} >保存</Button>
            <Button  htmlType="button" onClick={props.onCancel} >取消</Button>
          </Form.Item>
        </Form>
    </Card>
  </Col>
  </Row>
  </Modal>
  </>;
};

export default BomTechnology;
