import React from 'react';
import { Modal, Form, Input, Button, Select,InputNumber,TreeSelect } from 'antd';

const CreateForm = (props) => {

  return (
    <Modal
      title={props.values.id ? '编辑' : '新建'}
      width={640}
      visible={props.createModalVisible}
      bodyStyle={{ padding: '32px 40px 1px 48px' }}
      footer={null}
      onCancel={() => {
        props.onCancel();
      }}
      destroyOnClose
    >
      <Form
        labelCol={{ span: 4 }}
        layout="horizontal"
        initialValues={props.values}
        onFinish={props.onFinish}
      >
        <Form.Item name="id" hidden={true}>
          <Input />
        </Form.Item>
        <Form.Item name="attributeName" label="属性名称" rules={[{ required: true,max:50 }]}>
          <Input />
        </Form.Item>
        
        {/* <Form.Item
          name="goodsTypeId"
          label="商品小类"
          
          rules={[{ required: true, message: '请选择状态' }]}
        >
          <Select mode="multiple" allowClear>
            {
              props.goodstypeData == undefined ? '' :(
                props.goodstypeData.map((item, index) => {
                  return (
                    <Select.Option index={index} value={item.value} key={item.value}>
                      {item.label}
                    </Select.Option>
                  );
                })
              )
            }
          </Select>
        </Form.Item> */}
        <Form.Item name="goodsTypeId" label="商品类型" rules={[{ required: true }]}>
          <TreeSelect
            allowClear
            showSearch
            multiple
            treeCheckable= {true}
            showCheckedStrategy='SHOW_ALL'
            style={{ width: '100%' }}
            dropdownStyle={{ maxHeight: 400, overflow: 'auto' }}
            treeData={props.treeDatas}
            placeholder="请选择商品类型"
            treeDefaultExpandAll
          />
        </Form.Item>
        <Form.Item name="sort" label="排序"  rules={[{ required: true, message: '请输入排序号' }]} >
          <InputNumber />
        </Form.Item>
        <Form.Item>
        <Button  htmlType="button" style={{float:'right',left:10}} onClick={props.onCancel} >
                        取消
                    </Button>
        <Button type="primary" htmlType="submit" style={{float:'right'}} >
                        保存
                    </Button>
        </Form.Item>
      </Form>
    </Modal>
  );
};

export default CreateForm;
